Subject: Re: [Bitcoin-development] Ultimate Blockchain Compression w/ trust-free lite node

From: Gregory Maxwell <[email-masked]>
Date: Thu, 21 Jun 2012 18:02:27 -0400

On Thu, Jun 21, 2012 at 5:42 PM, Mike Koss <[email-masked]> wrote:
> Are we just talking about pruning the spent transactions from an old block?

No.

We're talking about commitments to the state of _unspent_ transactions
which would allow ~memoryless nodes to engage in full validation
without having to trust anything with the help of some untrusted
non-memoryless peers.  Also, talking about being able to securely
initialize new pruned nodes (not memoryless but reduced memory)
without exposing them to the old history of the chain. In both cases
this is possible without substantially degrading the full node
security model (rule violations prior to where they begin are only
undetectable with a conspiracy of the entire network).

But it requires a new data structure for managing these trees of
unspent transactions in a secure, scalable, and DOS resistant manner.
Fortunately there are lots of possibilities here.

> Does it really make sense to adopt a more complex data-structure than the merkle tree for inclusing in the bticoin protocol?

Yes. Though this is obviously not an ultra short term thing.